package com.fp.persistence.pcustomer.gene;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.GeneratedValue;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.persistence.Version;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

/**
 * Clase que implementa la entidad de Hibernate que hace referencia a la tabla TCUSTPERSONPERSONALREFERENCE
 */
@Entity(name = "TcustPersonPersonalReference")
@Table(name = "TCUSTPERSONPERSONALREFERENCE")
public class TcustPersonPersonalReference extends com.fp.dto.AbstractDataTransport implements Serializable, HibernateBean, Cloneable, Log {

    /**
     * HashCode asociado con la Instancia
     */
    @Transient
    private int hashValue = 0;

    /**
     * Version de la Clase
     */
    private static final long serialVersionUID = 1L;

    /**
     * Clave primaria de la Entidad TcustPersonPersonalReference
     */
    @EmbeddedId
    @GenericGenerator(name = "seq_id", strategy = "com.fp.general.keygen.SubSequenceKey", parameters = {
            @Parameter(name = "sql", value = "select coalesce(max(REFERENCESEQUENCE),0)+1 from TCUSTPERSONPERSONALREFERENCE where personcode=:code"),
            @Parameter(name = "type", value = "java.lang.Integer"), @Parameter(name = "param", value = "code,pk.personcode"),
            @Parameter(name = "field", value = "referencesequence") })
    @GeneratedValue(generator = "seq_id")
    private TcustPersonPersonalReferenceKey pk;

    @Column(name = "DATEFROM", nullable = true)
    /**
     * Fecha desde la cual esta vigente el registro del telefono
     */
    private Timestamp datefrom;

    @Version
    @Column(name = "RECORDVERSION", nullable = true)
    /**
     * Optimistic locking del registro
     */
    private Integer recordversion;

    @Column(name = "INGRESSUSERCODE", nullable = true)
    /**
     * Codigo de usuario
     */
    private String ingressusercode;

    @Column(name = "MODIFYUSERCODE", nullable = true)
    /**
     * Codigo de usuario
     */
    private String modifyusercode;

    @Column(name = "PERSONALREFCATALOG", nullable = true)
    /**
     * Codigo de catalogo 1 Padre, 2 Madre, 3 Hermano, 4 cuniado
     */
    private String personalrefcatalog;

    @Column(name = "PERSONALREFCATALOGCODE", nullable = true)
    /**
     * Codigo de tabla de catalogo PERSONALREF , referencias de personas
     */
    private String personalrefcatalogcode;

    @Column(name = "REFERENCEPERSONCODE", nullable = true)
    /**
     * Codigo de persona de referencia de la persona
     */
    private Integer referencepersoncode;

    @Column(name = "NAME", nullable = true)
    /**
     * Nombre de la persona de referencia
     */
    private String name;

    @Column(name = "REMARK", nullable = true)
    /**
     * Observaciones
     */
    private String remark;

    /**
     * Contructor por defecto
     */
    public TcustPersonPersonalReference() {
    }

    /**
     * Contructor de TcustPersonPersonalReference
     * 
     * @param pPk Clave Primaria del entity
     */
    public TcustPersonPersonalReference(TcustPersonPersonalReferenceKey pPk) {
        this();
        this.pk = pPk;
    }

    /**
     * Metodo que entrega datos de la tabla dada la clave primaria.
     * 
     * @param pEntityManager referencia de la session a obtener datos del bean.
     * @param pKey Caleve primaria del bean.
     * @return TcustPersonPersonalReference
     */
    public static TcustPersonPersonalReference find(EntityManager pEntityManager, TcustPersonPersonalReferenceKey pKey) throws Exception {
        TcustPersonPersonalReference obj = pEntityManager.find(TcustPersonPersonalReference.class, pKey);
        return obj;
    }

    /**
     * Entrega la Clave primaria de TcustPersonPersonalReference
     * 
     * @return El objeto que referencia a la Clave primaria de TcustPersonPersonalReference
     */
    public TcustPersonPersonalReferenceKey getPk() {
        return this.pk;
    }

    /**
     * Fija un nuevo valor a la Clave primaria de TcustPersonPersonalReference
     * 
     * @param pPk El objeto que referencia a la nueva Clave primaria de TcustPersonPersonalReference
     */
    public void setPk(TcustPersonPersonalReferenceKey pPk) {
        this.pk = pPk;
    }

    /**
     * Obtiene el valor de datefrom
     * 
     * @return valor de datefrom
     */
    public Timestamp getDatefrom() {
        return this.datefrom;
    }

    /**
     * Fija el valor de datefrom
     * 
     * @param pDatefrom nuevo Valor de datefrom
     */
    public void setDatefrom(Timestamp pDatefrom) {
        this.datefrom = pDatefrom;
    }

    /**
     * Obtiene el valor de recordversion
     * 
     * @return valor de recordversion
     */
    public Integer getRecordversion() {
        return this.recordversion;
    }

    /**
     * Fija el valor de recordversion
     * 
     * @param pRecordversion nuevo Valor de recordversion
     */
    public void setRecordversion(Integer pRecordversion) {
        this.recordversion = pRecordversion;
    }

    /**
     * Obtiene el valor de ingressusercode
     * 
     * @return valor de ingressusercode
     */
    public String getIngressusercode() {
        return this.ingressusercode;
    }

    /**
     * Fija el valor de ingressusercode
     * 
     * @param pIngressusercode nuevo Valor de ingressusercode
     */
    public void setIngressusercode(String pIngressusercode) {
        this.ingressusercode = pIngressusercode;
    }

    /**
     * Obtiene el valor de modifyusercode
     * 
     * @return valor de modifyusercode
     */
    public String getModifyusercode() {
        return this.modifyusercode;
    }

    /**
     * Fija el valor de modifyusercode
     * 
     * @param pModifyusercode nuevo Valor de modifyusercode
     */
    public void setModifyusercode(String pModifyusercode) {
        this.modifyusercode = pModifyusercode;
    }

    /**
     * Obtiene el valor de personalrefcatalog
     * 
     * @return valor de personalrefcatalog
     */
    public String getPersonalrefcatalog() {
        return this.personalrefcatalog;
    }

    /**
     * Fija el valor de personalrefcatalog
     * 
     * @param pPersonalrefcatalog nuevo Valor de personalrefcatalog
     */
    public void setPersonalrefcatalog(String pPersonalrefcatalog) {
        this.personalrefcatalog = pPersonalrefcatalog;
    }

    /**
     * Obtiene el valor de personalrefcatalogcode
     * 
     * @return valor de personalrefcatalogcode
     */
    public String getPersonalrefcatalogcode() {
        return this.personalrefcatalogcode;
    }

    /**
     * Fija el valor de personalrefcatalogcode
     * 
     * @param pPersonalrefcatalogcode nuevo Valor de personalrefcatalogcode
     */
    public void setPersonalrefcatalogcode(String pPersonalrefcatalogcode) {
        this.personalrefcatalogcode = pPersonalrefcatalogcode;
    }

    /**
     * Obtiene el valor de referencepersoncode
     * 
     * @return valor de referencepersoncode
     */
    public Integer getReferencepersoncode() {
        return this.referencepersoncode;
    }

    /**
     * Fija el valor de referencepersoncode
     * 
     * @param pReferencepersoncode nuevo Valor de referencepersoncode
     */
    public void setReferencepersoncode(Integer pReferencepersoncode) {
        this.referencepersoncode = pReferencepersoncode;
    }

    /**
     * Obtiene el valor de name
     * 
     * @return valor de name
     */
    public String getName() {
        return this.name;
    }

    /**
     * Fija el valor de name
     * 
     * @param pName nuevo Valor de name
     */
    public void setName(String pName) {
        this.name = pName;
    }

    /**
     * Obtiene el valor de remark
     * 
     * @return valor de remark
     */
    public String getRemark() {
        return this.remark;
    }

    /**
     * Fija el valor de remark
     * 
     * @param pRemark nuevo Valor de remark
     */
    public void setRemark(String pRemark) {
        this.remark = pRemark;
    }

    @Override
    public boolean equals(Object rhs) {
        if (rhs == null) {
            return false;
        }
        if (!(rhs instanceof TcustPersonPersonalReference)) {
            return false;
        }
        TcustPersonPersonalReference that = (TcustPersonPersonalReference) rhs;
        if ((this.getPk() == null) || (that.getPk() == null)) {
            return false;
        }
        return (this.getPk().equals(that.getPk()));
    }

    /**
     * Implementaci�n del metodo hashCode de la la entidad TcustPersonPersonalReference
     * 
     * @return el hashCode la instancia
     */
    @Override
    public int hashCode() {
        if (this.hashValue == 0) {
            int result = 17;
            if (this.getPk() == null) {
                result = super.hashCode();
            } else {
                result = this.getPk().hashCode();
            }
            this.hashValue = result;
        }
        return this.hashValue;
    }

    /**
     * Implementaci�n toString
     */
    @Override
    public String toString() {
        Field[] fs = this.getClass().getDeclaredFields();
        String data = "";
        for (Field f : fs) {
            try {
                String name = f.getName();
                if (f.getType().getName().compareTo("java.util.Set") == 0) {
                    continue;
                }
                if ((name.compareTo("hashValue") == 0) || (name.compareTo("serialVersionUID") == 0)) {
                    continue;
                }
                data += name + "=" + f.get(this) + ";";
            } catch (Exception e) {
                continue;
            }
        }
        if (data.compareTo("") == 0) {
            data = super.toString();
        }
        return data;
    }

    /**
     * Implementaci�n de la creaci�n de un bean en blanco TcustPersonPersonalReference
     */
    @Override
    public Object createInstance() {
        TcustPersonPersonalReference instance = new TcustPersonPersonalReference();
        instance.setPk(new TcustPersonPersonalReferenceKey());
        return instance;
    }

    /**
     * Clona la entidad TcustPersonPersonalReference
     * 
     * @see com.fp.dto.hb.HibernateBean#cloneMe()
     */
    @Override
    public Object cloneMe() throws CloneNotSupportedException {
        TcustPersonPersonalReference p = (TcustPersonPersonalReference) this.clone();
        p.setPk((TcustPersonPersonalReferenceKey) this.pk.cloneMe());
        return p;
    }

    public Object getId() {
        return this.pk;
    }
}
